// registers ClipboardHistoryAX ActiveX objects (simulates regasm registration)
// many thanks to Frederic Queudret for the following function
function regAsm(root, progId, cls, clsid, assembly, version, codebase) {
    var wshShell = new ActiveXObject("WScript.Shell");
    var alreadyRegistered = "";
    var regPath = "";
    
    if ("HKCR" == root)
    {
        regPath = root + "\\";
    }
    else
    {
        regPath = root + "\\Software\\Classes\\"
    }
    
    try
    {
        alreadyRegistered = wshShell.RegRead (regPath + progId + "\\");
    }
    catch(err) {}

    if (alreadyRegistered == "")
    {
        wshShell.RegWrite(regPath, progId);
        wshShell.RegWrite(regPath + progId + "\\", cls);
        wshShell.RegWrite(regPath + progId + "\\CLSID\\", clsid);
        wshShell.RegWrite(regPath + "CLSID\\" + clsid + "\\", cls);

        wshShell.RegWrite(regPath + "CLSID\\" + clsid + "\\InprocServer32\\", "mscoree.dll");
        wshShell.RegWrite(regPath + "CLSID\\" + clsid + "\\InprocServer32\\ThreadingModel", "Both");
        wshShell.RegWrite(regPath + "CLSID\\" + clsid + "\\InprocServer32\\Class", cls);
        wshShell.RegWrite(regPath + "CLSID\\" + clsid + "\\InprocServer32\\Assembly", assembly);
        wshShell.RegWrite(regPath + "CLSID\\" + clsid + "\\InprocServer32\\RuntimeVersion", "v2.0.50727");
        wshShell.RegWrite(regPath + "CLSID\\" + clsid + "\\InprocServer32\\CodeBase", codebase);

        wshShell.RegWrite(regPath + "CLSID\\" + clsid + "\\InprocServer32\\" + version + "\\Class", cls);
        wshShell.RegWrite(regPath + "CLSID\\" + clsid + "\\InprocServer32\\" + version + "\\Assembly", assembly);
        wshShell.RegWrite(regPath + "CLSID\\" + clsid + "\\InprocServer32\\" + version + "\\RuntimeVersion", "v2.0.50727");
        wshShell.RegWrite(regPath + "CLSID\\" + clsid + "\\InprocServer32\\" + version + "\\CodeBase", codebase);

        wshShell.RegWrite(regPath + "CLSID\\" + clsid + "\\ProgId\\", progId);

        wshShell.RegWrite(regPath + "CLSID\\" + clsid + "\\Implemented Categories\\{62C8FE65-4EBB-45E7-B440-6E39B2CDBF29}\\", "");
    }
} 

function registerClipboardHistoryAX(root)
{
    try
    {
        regAsm(
            root, 
            "Com.HonzaZeman.ClipboardHistoryAX",
            "Com.HonzaZeman.ClipboardHistoryAX",
            "{66A923BA-DBC7-477C-9188-8CFCA84516F6}",
            "Com.HonzaZeman.ClipboardHistory, Version=1.1.0.0, Culture=neutral, PublicKeyToken=ee8694fc2c9f0c5d",
            "1.1.0.0",
            System.Gadget.path + "\\ClipboardHistoryAX\\Com.HonzaZeman.ClipboardHistory.dll");
     }
     catch(err)
     {
        System.Debug.outputString("Registering ClipboardHistoryAX(" + root + "): " + err.name + " - " + err.message);
        return false;
     }

     return true;
}

function tryToRegisterClipboardHistoryAX()
{
    //Jonathan Abbott: http://forums.microsoft.com/MSDN/ShowPost.aspx?PageIndex=2&SiteID=1&PostID=1091653
    //If you want to distribute it with the Gadget, you need to find out what reg entries 
    //it creates under HKLM and progammatically put them into HKCU as the Gadget loads.
    //I have noticed that this only works if the user is not an elevated Administrator.
    //For it to work as an elevated Administrator, you need to register to HKLM.
    registerClipboardHistoryAX("HKCU");
    if (!registerClipboardHistoryAX("HKLM"))
        registerClipboardHistoryAX("HKCR");
}

