var backgroundFilesCount = 0;

function InitSettings()
{
    // read settings if present
    if (System.Gadget.Settings.read("settingsSaved"))
    {
		backgroundFilesCount = System.Gadget.Settings.read("backgroundFilesCount");

		backgroundImageIndex = System.Gadget.Settings.read("backgroundImageIndex");
		if (backgroundImageIndex != "")
		{ 
			PreviewBackgroundImage();
		}

		var charsPerItem = System.Gadget.Settings.read("charsPerItem");
		if (charsPerItem != "")
		{ 
			charsPerItemInput.innerText = charsPerItem;
		}

		var fontSize = System.Gadget.Settings.read("fontSize");
		if (fontSize != "")
		{
			fontSizeInput.innerText = fontSize;
		}
		
		var fontColor = System.Gadget.Settings.read("fontColor");
		if (fontColor == 0)
		    fontColor = "000000";
		if (fontColor != "")
		{
			fontColorInput.innerText = fontColor;
		}
	}
}

System.Gadget.onSettingsClosing = SettingsClosing;
function SettingsClosing(event)
{
	if (event.closeAction == event.Action.commit) // save just chosen settings
	{
		System.Gadget.Settings.write("settingsSaved", true);
		System.Gadget.Settings.write("backgroundImageIndex", backgroundImageIndex);
		System.Gadget.Settings.write("charsPerItem", charsPerItemInput.value);
		System.Gadget.Settings.write("fontSize", fontSizeInput.value);
		System.Gadget.Settings.write("fontColor", fontColorInput.value);
	}
	
	event.cancel = false;
}

function PreviewBackgroundImage()
{
    backgroundImagePreview.src = "backgrounds/" + backgroundImageIndex + ".png";
}

function PreviewBackgroundImageForward()
{
    backgroundImageIndex++;
    if (backgroundImageIndex > backgroundFilesCount)
    {
        backgroundImageIndex = 1;
    }
    PreviewBackgroundImage();
}

function PreviewBackgroundImageBack()
{
	backgroundImageIndex--;
	if (backgroundImageIndex < 1)
	{
	    backgroundImageIndex = backgroundFilesCount;
	}
    PreviewBackgroundImage();
}

function SettingsUpdateImage(img, state)
{
    img.src = "images/" + "settings_" + img.src.split("_")[1] + "_" + state + ".png";
}